=== kdevplatform/pics/CMakeLists.txt ===
ecm_install_icons(
    ICONS
        16-actions-breakpoint.png
        22-actions-breakpoint.png
        32-actions-breakpoint.png
        sc-actions-breakpoint.svg
    DESTINATION ${KDE_INSTALL_ICONDIR}
    THEME hicolor
)
