=== debian/changelog ===
kdevelop (4:24.12.3-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Build depend on current gear version of libkomparediff2.
    - Only try to build on architectures where QtWebEngine is available.

 -- Rik Mills <rikmills@kde.org>  Mon, 24 Mar 2025 06:21:34 +0000

kdevelop (4:24.12.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Drop the kinit dependency, as kinit is no more in KF6.
  * Concatenate all the keys in debian/upstream/signing-key.asc.
  * CI: update/simplify configuration.
  * Restore the libastyle-dev build dependency for the astyle plugin, removed
    in version 4:24.12.0-1.
  * Since kdevelop requires Qt WebEngine, which is available only on few
    architectures and all of those have clang, then drop the bits to support
    architectures without clang:
    - drop the patch optional-clang.diff
    - drop the architecture exclusions from the clang, and llvm-dev build
      dependencies
    - drop the code to set an empty value for the ${kdevelop:clang} substvar
    - drop manual creation of /usr/share/kdevclangsupport
    - drop the architecture exclusions for few files in debian/kdevelop.install
  * Now that there are no more architecture exclusions in install files,
    use the debhelper 13 replacement features in install files:
    - switch from ${KDEV_PLUGIN_VERSION} to ${env:KDEV_PLUGIN_VERSION}
    - remove the dh-exec build dependency, no more needed
    - remove the lintian override for the old method

 -- Pino Toscano <pino@debian.org>  Sun, 23 Mar 2025 20:13:16 +0100
